
/*
 *                            COPYRIGHT
 *
 *  XAnalyser, frequence spectrum analyser for X Windows
 *  Copyright (C) 1998 Arvin Schnell
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Contact addresses:
 *  aschnell@physik.uni-bremen.de or arvinschnell@yahoo.com
 *  Arvin Schnell, Am Heidberg 8, 28865 Lilienthal, Germany
 *
 */


#include <stdlib.h>
#include <iostream.h>
#include <builtin.h>

#include <X11/Xlib.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/PushB.h>
#include <Xm/Text.h>

#include "main.hh"
#include "control.hh"


String help_txt[] = {
#include "help.txt.h"
  NULL
};


Widget help_w;


void
help_create()
{
  Arg args[10];
  int n;
  
  Widget close_w, text_w;
  
  
  // form
  
  n = 0;
  XtSetArg( args[n], XtNiconPixmap, icon_pixmap ); n++;
  XtSetArg( args[n], XtNiconMask, icon_mask ); n++;
  help_w = XmCreateFormDialog( toplevel, "Help", args, n );
  
  
  // button: close
  
  n = 0;
  XtSetArg( args[n], XmNbottomAttachment, XmATTACH_FORM ); n++;
  XtSetArg( args[n], XmNbottomOffset, 10 ); n++;
  XtSetArg( args[n], XmNleftAttachment, XmATTACH_POSITION ); n++;
  XtSetArg( args[n], XmNleftPosition, 40 ); n++;
  XtSetArg( args[n], XmNrightAttachment, XmATTACH_POSITION ); n++;
  XtSetArg( args[n], XmNrightPosition, 60 ); n++;
  close_w = XmCreatePushButton( help_w, "Close", args, n );
  XtManageChild( close_w );
  
  
  // scrolled text: text
  
  n = 0;
  XtSetArg( args[n], XmNtopAttachment, XmATTACH_FORM ); n++;
  XtSetArg( args[n], XmNbottomAttachment, XmATTACH_WIDGET ); n++;
  XtSetArg( args[n], XmNbottomWidget, close_w ); n++;
  XtSetArg( args[n], XmNbottomOffset, 10 ); n++;
  XtSetArg( args[n], XmNleftAttachment, XmATTACH_FORM ); n++;
  XtSetArg( args[n], XmNrightAttachment, XmATTACH_FORM ); n++;
  XtSetArg( args[n], XmNeditMode, XmMULTI_LINE_EDIT ); n++;
  XtSetArg( args[n], XmNeditable, False ); n++;
  XtSetArg( args[n], XmNcursorPositionVisible, False ); n++;
  text_w = XmCreateScrolledText( help_w, "HelpText", args, n );
  XtManageChild( text_w );
  
  
  int pos = 0;
  for( int i = 0; ; i++ ) {
    
    if( help_txt[i] == NULL )
      break;
    
    char tmp[200];
    strcpy( tmp, help_txt[i] );
    strcat( tmp, "\n" );
    
    XmTextReplace( text_w, pos, pos, tmp );
    pos += strlen( tmp );
  }
  
}



void
help_manage()
{
  if( !help_w )
    help_create();
  
  if( !XtIsManaged( help_w ) )
    XtManageChild( help_w );
  else
    XMapRaised( XtDisplay( help_w ), XtWindow( XtParent( help_w ) ) );
}

